#include <SoftwareSerial.h>

const int RX = 11;
const int TX = 10;
SoftwareSerial MySerial(RX,TX);

const int RELAY_1 = 2;              // Подключаем реле к пину 2
const int RELAY_2 = 3;              // Подключаем реле к пину 2
boolean relay1_st = true;           // Выставляем высокий уровень(выключаем реле)
boolean relay2_st = true;
//Переменные для хранения входящих данных
String buff;
String dtmf;
boolean is_call = false;            // Звонок
 
void setup()
{
  pinMode(RELAY_1, OUTPUT);
  pinMode(RELAY_2, OUTPUT);
  digitalWrite(RELAY_1, HIGH);
  digitalWrite(RELAY_2, HIGH);
  
  Serial.begin(9600); 
  MySerial.begin(9600);
  Serial.println(F("Подключение GSM модуля SIM800L"));
  delay(5000);                      // Задержка в 5 секунд 

  MySerial.println(F("AT"));        // Подключаемся к режиму AT для настройки скорости обмена данными
  delay(500);

  MySerial.println(F("AT+DDET=1")); //Включение DTMF(тонального набора)
  delay(500);
}

void loop()
{
  while(MySerial.available()){
    buff = MySerial.readString();
    Serial.println(buff);    
    if(is_call = true)              // Если вызов прошёл
    {
      if(int index = buff.indexOf("+DTMF:") > -1 )// Ищем первое совпадение. Если не -1 значит нашли.
      {
        index = buff.indexOf(":");  // Ищем :
        dtmf = buff.substring(index+1, buff.length()); // Возвращает подстроку в строке 
        dtmf.trim();                // обрезает все пробелы в начале и конце указанной строки.
        Serial.println("dtmf: "+dtmf);// Выводит полученное значение
        State();
      }    
      if(buff.indexOf("NO CARRIER") > -1)
      {
        MySerial.println(F("ATH"));   // Повесить трубку/ разорвать соединение
        is_call = false;
      }
    }
    if(buff.indexOf("RING") > -1)     // Входящий звонок
    {
      delay(2000);
      MySerial.println(F("ATA"));     // Ответить на звонок
      is_call = true;
    }
  }  
  while(Serial.available()){
    MySerial.println(Serial.readString());
  }
}


void State(){
  if(dtmf == "1"){
    relay1_st = !relay1_st; 
    digitalWrite(RELAY_1, relay1_st);   // Включаем или выключаем реле 1
  }

   else if(dtmf == "2"){
    relay2_st = !relay2_st;  
    digitalWrite(RELAY_2, relay2_st);   // Включаем или выключаем реле 2
  }
 
}
